<script lang="ts">
	interface Props {
		items?: Array<{ label: string; value: number; component: any; data: any }>;
		activeTabValue?: number;
		fixed?: boolean;
		style?: string | undefined;
	}

	let {
		items = [],
		activeTabValue = $bindable(1),
		fixed = false,
		style = ''
	}: Props = $props();

	let ulStyle = $derived(`${fixed ? 'position: fixed; width: 100%;' : ''} ${style}`)

	const handleClick = (tabValue: number) => () => (activeTabValue = tabValue)

	function handleKeyPress(e: KeyboardEvent, tabValue: number) {
		console.log(e)
		if (e.key === 'Enter' || e.key === ' ') {
			handleClick(tabValue)()
		}
	}
</script>

<ul style={ulStyle}>
	{#each items as item}
		<li class={activeTabValue == item.value ? 'active' : ''}>
			<!-- svelte-ignore a11y_no_noninteractive_tabindex -->
			<span tabindex="0" onclick={handleClick(item.value)} onkeypress={(e) => handleKeyPress(e, item.value)}
				>{item.label}</span
			>
		</li>
	{/each}
</ul>
{#if fixed}
	<div class="spacing"></div>
{/if}
{#each items as item}
	{#if activeTabValue == item.value}
		<div class="box">
			<item.component data={item.data} />
		</div>
	{/if}
{/each}

<style>
	@media (pointer: none), (pointer: coarse) {
		.box {
			margin-top: auto;
		}
	}
	.box {
		padding-top: 1rem;
		border-top: 0;
	}

	.spacing {
		height: 4rem;
	}
	ul {
		display: flex;
		flex-wrap: wrap;
		padding-left: 0;
		margin-top: 0;
		margin-bottom: 0;
		list-style: none;
		justify-content: space-around;
		background-color: #161616;
	}
	li {
		margin-bottom: -1px;
		width: auto;
		flex-grow: 1;
		flex-basis: 0;
		color: #666;
		font-family: Quicksand;
		font-weight: 500;
		font-size: 1.3rem;
	}

	span {
		display: block;
		padding: 1rem 1rem;
		cursor: pointer;
	}

	li.active > span {
		color: #fff;
		background-color: #252525;
		border-style: solid;
		border-top: 0;
		border-left: 0;
		border-right: 0;
		border-bottom: 1;
		border-bottom-width: 2px;
		border-color: var(--accentColour);
	}
</style>
